/* File BTLE_Assigned_Numbers.h */

#ifndef __BTLE_ASSIGNED_NUMBERS_H_
#define __BTLE_ASSIGNED_NUMBERS_H_

// Defines for RACP operations
#define BTLE_RACP_GET_ALL_RECORDS 1
#define BTLE_RACP_GET_NUMBER_OF_ALL_RECORDS 2
#define BTLE_RACP_DELETE_ALL_RECORDS 3

#define BTLE_GLUCOSE_RACP_NUMBER_OF_RECORDS_RESPONSE 5
#define BTLE_GLUCOSE_RACP_RESPONSE 6
/*
 * Bluetooth Low Energy Assigned Service Numbers 16 bit
 */
#define BTLE_GENERIC_ACCESS_PROFILE_SERVICE 0x1800
#define BTLE_CURRENT_TIME_SERVICE 0x1805
#define BTLE_THERMOMETER_SERVICE 0x1809
#define BTLE_DEVICE_INFORMATION_SERVICE 0x180A
#define BTLE_HEART_RATE_SERVICE 0x180D
#define BTLE_BLOOD_PRESSURE_SERVICE 0x1810
#define BTLE_GLUCOSE_SERVICE 0x1808
#define BTLE_WEIGHT_SCALE_SERVICE 0x181D
#define BTLE_BODY_COMPOSITION_SERVICE 0x181B
#define BTLE_PULSE_OX_SERVICE 0x1822
#define BTLE_REF_TIME_UPDATE_SERVICE 0x1806
#define BTLE_BATTERY_SERVICE 0x180F
#define BTLE_USER_DATA_SERVICE 0x181C

#define BTLE_USER_DATA_FIRST_NAME_CHAR 0x2A8A
#define BTLE_USER_DATA_LAST_NAME_CHAR 0x2A90
#define BTLE_USER_DATA_EMAIL_ADDRESS_CHAR 0x2A87
#define BTLE_USER_DATA_AGE_CHAR 0x2A80
#define BTLE_USER_DATA_DATE_OF_BIRTH_CHAR 0x2A85
#define BTLE_USER_DATA_GENDER_CHAR 0x2A8C
#define BTLE_USER_DATA_WEIGHT_CHAR 0x2A98
#define BTLE_USER_DATA_HEIGHT_CHAR 0x2A8E
#define BTLE_USER_DATA_VO2_MAX_CHAR 0x2A96
#define BTLE_USER_DATA_HEART_RATE_MAX_CHAR 0x2A8D
#define BTLE_USER_DATA_RESTING_HEART_RATE_CHAR 0x2A92
#define BTLE_USER_DATA_MAX_RECOMMENDED_HEART_RATE_CHAR 0x2A91
#define BTLE_USER_DATA_AEROBIC_THRESHOLD_CHAR 0x2A7F
#define BTLE_USER_DATA_ANAEROBIC_THRESHOLD_CHAR 0x2A83
#define BTLE_USER_DATA_SPORT_TYPE_FOR_AEROBIC_AND_ANAEROBIC_THRESHOLDS_CHAR 0x2A93
#define BTLE_USER_DATA_DATE_OF_THRESHOLD_ASSESSMENT_CHAR 0x2A86
#define BTLE_USER_DATA_WAIST_CIRCUMFERENCE_CHAR 0x2A97
#define BTLE_USER_DATA_HIP_CIRCUMFERENCE_CHAR 0x2A8F
#define BTLE_USER_DATA_FAT_BURN_HEART_RATE_LOWER_LIMIT_CHAR 0x2A88
#define BTLE_USER_DATA_FAT_BURN_HEART_RATE_UPPER_LIMIT_CHAR 0x2A89
#define BTLE_USER_DATA_AEROBIC_HEART_RATE_LOWER_LIMIT_CHAR 0x2A7E
#define BTLE_USER_DATA_AEROBIC_HEART_RATE_UPPER_LIMIT_CHAR 0x2A84
#define BTLE_USER_DATA_ANAEROBIC_HEART_RATE_LOWER_LIMIT_CHAR 0x2A81
#define BTLE_USER_DATA_ANAEROBIC_HEART_RATE_UPPER_LIMIT_CHAR 0x2A82
#define BTLE_USER_DATA_FIVE_ZONE_HEART_RATE_LIMITS_CHAR 0x2A8B
#define BTLE_USER_DATA_THREE_ZONE_HEART_RATE_LIMITS_CHAR 0x2A94
#define BTLE_USER_DATA_TWO_ZONE_HEART_RATE_LIMITS_CHAR 0x2A95
#define BTLE_USER_DATA_DATABASE_CHANGE_INCREMENT_CHAR 0x2A99
#define BTLE_USER_DATA_USER_INDEX_CHAR 0x2A9A
#define BTLE_USER_DATA_USER_CONTROL_POINT_CHAR 0x2A9F
#define BTLE_USER_DATA_LANGUAGE_CHAR 0x2AA2
#define BTLE_BATTERY_LEVEL_CHAR 0x2A19
#define BTLE_BLOOD_PRESSURE_FEATURE_CHAR 0x2A49
#define BTLE_BLOOD_PRESSURE_MEASUREMENT_CHAR 0x2A35
#define BTLE_THERMOMETER_MEASUREMENT_PERIOD_CHAR 0x2A21
#define BTLE_THERMOMETER_MEASUREMENT_TYPE_CHAR 0x2A1D
#define BTLE_TEMPERATURE_MEASUREMENT_CHAR 0x2A1C
#define BTLE_WEIGHT_SCALE_MEASUREMENT_CHAR 0x2A9D
#define BTLE_WEIGHT_SCALE_FEATURE_CHAR 0x2A9E
#define BTLE_BODY_COMPOSITION_FEATURE_CHAR 0x2A9B
#define BTLE_BODY_COMPOSITION_MEASUREMENT_CHAR 0x2A9C
#define BTLE_BCA_MEASUREMENT_CHAR 0x2A9C
#define BTLE_BCA_FEATURE_CHAR 0x2A9B
#define BTLE_HRM_MEASUREMENT_CHAR 0x2A37
#define BTLE_HRM_SENSOR_LOCATION 0x2A38
#define BTLE_HRM_CONTROL_POINT 0x2A39
#define BTLE_USER_DATA_SERVICE 0x181C
#define BTLE_DIS_MANUFACTURER_DEVICE_NAME_CHAR 0x2A29
#define BTLE_DIS_MODEL_NUMBER_CHAR 0x2A24
#define BTLE_DIS_SERIAL_NUMBER_CHAR 0x2A25
#define BTLE_DIS_FIRMWARE_REVISION_CHAR 0x2A26
#define BTLE_DIS_HARDWARE_REVISION_CHAR 0x2A27
#define BTLE_DIS_SOFTWARE_REVISION_CHAR 0x2A28
#define BTLE_DIS_REG_CERT_DATA_LIST_CHAR 0x2A2A
#define BTLE_DIS_SYSTEM_ID_CHAR 0x2A23
#define BTLE_PRIMARY_SERVICE_UUID 0x2800
#define BTLE_SECONDARY_SERVICE_UUID 0x2801
#define BTLE_INCLUDE_UUID 0x2802
#define BTLE_CHAR_DECLARATION_UUID 0x2803
#define BTLE_CLIENT_CHAR_DESCRIPTOR_UUID 0x2902
#define BTLE_CURRENT_TIME_CHAR 0x2A2B
#define BTLE_GAP_DEVICE_NAME 0x2A00
#define BTLE_GAP_APPEARANCE 0x2A01
#define BTLE_GAP_PERIPHERAL_PRIVACY_FLAG 0x2A02
#define BTLE_GAP_RECONNECTION_ADDRESS 0x2A03
#define BTLE_RECORD_ACCESS_CONTROL_POINT 0x2A52
#define BTLE_GLUCOSE_MEASUREMENT_CHAR 0x2A18
#define BTLE_GLUCOSE_MEASUREMENT_CONTEXT_CHAR 0x2A34
#define BTLE_GLUCOSE_FEATURE_CHAR 0x2A51
#define BTLE_RECORD_ACCESS_CONTROL_POINT 0x2A52
#define BTLE_PULSEOX_SPOT_MEASUREMENT_CHAR 0x2A5E
#define BTLE_PULSEOX_CONTINUOUS_MEASUREMENT_CHAR 0x2A5F
#define BTLE_PULSEOX_FEATURES_CHAR 0x2A60

#define BTLE_DATE_TIME_CHAR 0x2A08
#define BTLE_DAY_DATE_TIME_CHAR 0x2A0A
#define BTLE_DAY_OF_WEEK_CHAR 0x2A09
#define BTLE_DST_OFFSET_CHAR 0x2A0D     // Daylight savings
#define BTLE_EXACT_TIME_256_CHAR 0x2A0C  // Includes fractions

#endif  /* __BTLE_ASSIGNED_NUMBERS_H */