#include <stddef.h>
#include <stdlib.h>
#include <string.h>
#include "Specializations.h"

int main(int argc, char* argv[])
{
    char *serialPort = NULL;
    int result = 0;
    int i;
    s_disCharValues disCharValues;
    unsigned char hrsystemId[8] = { 0xFE, 0xED, 0xAB, 0xEE, 0xDE, 0xAD, 0xBE, 0xEF }; // little endian order!
    unsigned char regCertDataList[22] = { 0, 2, 0, 0x12, 2, 1, 0, 8, 5, 0, 0, 1, 0, 2, 0x80, 6, 2, 2, 0, 2, 0x80, 0 };
    unsigned char bluetoothAddress[6] = {0x45, 0x67, 0x89, 0xAB, 0xCD, 0xEE};
    if (argc > 1)
    {
        serialPort = argv[1];
    }
    s_hrParams *hrParams = calloc(1, sizeof(s_hrParams));
    if (hrParams != NULL)
    {
        hrParams->numberOfMsmts = 4;
        hrParams->hrMsmtChar = calloc(1, hrParams->numberOfMsmts * sizeof(s_hrMsmtChar*));
        if (hrParams->hrMsmtChar != NULL)
        {
            for (i = 0; i < hrParams->numberOfMsmts; i++)
            {
                hrParams->hrMsmtChar[i] = (s_hrMsmtChar*)calloc(1, sizeof(s_hrMsmtChar));
                if (hrParams->hrMsmtChar[i] != NULL)
                {
                    hrParams->hrMsmtChar[i]->energyExpendedStatusFlag = 0;
                    hrParams->hrMsmtChar[i]->hrSensorContactFlag = 0;
                    hrParams->hrMsmtChar[i]->hrFormatFlag = 0;
                    hrParams->hrMsmtChar[i]->RRntervalPresentFlag = HR_RR_INTERVALS_FLAG;
                    hrParams->hrMsmtChar[i]->heartRate = 40 + i * 3;
                    hrParams->hrMsmtChar[i]->numberOfRrIntervals = 2;
                    hrParams->hrMsmtChar[i]->rrIntervals = calloc(1, hrParams->hrMsmtChar[i]->numberOfRrIntervals * sizeof(short int));
                    if (hrParams->hrMsmtChar[i]->rrIntervals != NULL)
                    {
                        hrParams->hrMsmtChar[i]->rrIntervals[0] = (1024 * 60 + hrParams->hrMsmtChar[i]->heartRate / 2) / hrParams->hrMsmtChar[i]->heartRate;
                        hrParams->hrMsmtChar[i]->rrIntervals[1] = 1024;
                    }
                }
            }
        }
        memcpy(disCharValues.systemId, hrsystemId, 8);
        disCharValues.regCertDataListLength = 22;
        disCharValues.regCertDataList = calloc(1, disCharValues.regCertDataListLength * sizeof(unsigned char));
        if (disCharValues.regCertDataList != NULL)
        {
            memcpy(disCharValues.regCertDataList, regCertDataList, disCharValues.regCertDataListLength);
        }
        disCharValues.firmwareRevision = "fw3.4.1";
        disCharValues.hardwareRevision = "hw8.0.4";
        disCharValues.softwareRevision = "sw13.4.7";
        disCharValues.manufacturerName = "Lamprey Networks, Inc";
        disCharValues.modelNumber = "nRF52840";
        disCharValues.serialNumber = "sn8334529";
        hrParams->disCharValues = &disCharValues;
        hrParams->deviceName = "HeartRate1";
        hrParams->invokeServiceChanged = false;
        memcpy(hrParams->bluetoothAddress, bluetoothAddress, 6);

        result = runHeartRateMonitor(serialPort, hrParams);
        result = runHeartRateMonitor(serialPort, hrParams);

        free(disCharValues.regCertDataList);
        hrParams->disCharValues = NULL;
        for (i = 0; i < hrParams->numberOfMsmts; i++)
        {
            if (hrParams->hrMsmtChar != NULL && hrParams->hrMsmtChar[i] != NULL)
            {
                hrParams->hrMsmtChar[i]->energyExpendedStatusFlag = 0;
                hrParams->hrMsmtChar[i]->hrSensorContactFlag = 0;
                hrParams->hrMsmtChar[i]->hrFormatFlag = 0;
                hrParams->hrMsmtChar[i]->RRntervalPresentFlag = 0;
                hrParams->hrMsmtChar[i]->heartRate = 80 - i * 3;
                hrParams->hrMsmtChar[i]->numberOfRrIntervals = 2;
            }
        }
   //  Comment out next two lines to set up Service Changed
   //     hrParams->bluetoothAddress[5] = 0xEF;
   //     hrParams->deviceName = "HeartRate2";
   // Set to 'true' to invoke service changed
		hrParams->invokeServiceChanged = true;
        result = runHeartRateMonitor(serialPort, hrParams);

        // Clean up
        for (i = 0; i < hrParams->numberOfMsmts; i++)
        {
            if (hrParams->hrMsmtChar != NULL && hrParams->hrMsmtChar[i] != NULL)
            {
                if (hrParams->hrMsmtChar[i]->rrIntervals != NULL)
                {
                    free(hrParams->hrMsmtChar[i]->rrIntervals);
                }
                free(hrParams->hrMsmtChar[i]);
            }
        }
        free(hrParams->hrMsmtChar);
        free(hrParams);
    }
    return result;
}